Public Class FileList
    Private head As FileNode
    Private tail As FileNode
    Private length As Int32

    Public Sub New()
        head = Nothing
        tail = Nothing
        length = 0
    End Sub

    Public Sub addFile(ByVal path As String)
        If length = 0 Then
            head = New FileNode(path)
            tail = head
        Else
            tail.nextNode = New FileNode(path)
            tail = tail.nextNode
        End If
        length += 1
    End Sub

    Public Sub clear()
        length = 0
        head = Nothing
        tail = Nothing
    End Sub

    Public Function getLength() As Int32
        Return length
    End Function

    Public Function getFileArray() As String()
        If length = 0 Then
            Return Nothing
        Else
            Dim rtrArr(length - 1) As String
            Dim tmpNode As FileNode = head
            Dim i As Int32 = 0
            While Not tmpNode Is Nothing
                rtrArr(i) = tmpNode.fileName
                i += 1
                tmpNode = tmpNode.nextNode
            End While
            Return rtrArr
        End If
    End Function

End Class

Public Class FileNode
    Public fileName As String
    Public nextNode As FileNode

    Public Sub New(ByVal fileName As String)
        Me.fileName = fileName
        Me.nextNode = Nothing
    End Sub
End Class
