Public Class FolderList
    Private Length As Int32
    Private headNode As FolderNode
    Private tailNode As FolderNode

    Public Sub New()
        Length = 0
        headNode = Nothing
        tailNode = Nothing
    End Sub

    Public Sub addFolder(ByVal path As String)
        If Length = 0 Then
            headNode = New FolderNode(path)
            tailNode = headNode
        Else
            tailNode.nextNode = New FolderNode(path)
            tailNode = tailNode.nextNode
        End If
        Length += 1
    End Sub

    Public Sub clearFolders()
        Length = 0
        headNode = Nothing
        tailNode = Nothing
    End Sub

    Public Function getFolderString() As String
        Dim rtrStr As String = ""
        Dim tmpNode As FolderNode = headNode
        While Not tmpNode Is Nothing
            rtrStr &= tmpNode.folderPath & vbCrLf
            tmpNode = tmpNode.nextNode
        End While
        Return rtrStr
    End Function

    Public Function getFoldersArray() As String()
        If Length > 0 Then
            Dim rtrArr(Length - 1) As String
            Dim i As Int32 = 0
            Dim tmpNode As FolderNode = headNode
            While Not tmpNode Is Nothing
                rtrArr(i) = tmpNode.folderPath
                i += 1
                tmpNode = tmpNode.nextNode
            End While
            Return rtrArr
        Else
            Return Nothing
        End If
    End Function

End Class





Public Class FolderNode
    Public folderPath As String
    Public nextNode As FolderNode

    Public Sub New()
        Me.folderPath = ""
        Me.nextNode = Nothing
    End Sub
    Public Sub New(ByVal path As String)
        Me.folderPath = path
        Me.nextNode = Nothing
    End Sub
    Public Sub New(ByVal path As String, ByVal nextNode As FolderNode)
        Me.folderPath = path
        Me.nextNode = nextNode
    End Sub
End Class